
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_GLOBAL_H
#define INITNG_GLOBAL_H
#include "initng.h"
#include "initng_service_cache.h"
#include "initng_active_db.h"
#include "initng_module.h"
#include "initng_plugin.h"
#include "initng_struct_data.h"
#include "initng_control_command.h"
#include "initng_static_data_id.h"

/* what to do when last process stops */
typedef enum
{
    THEN_NONE,
    THEN_QUIT,
    THEN_RESTART,
    THEN_SULOGIN,
    THEN_NEW_INIT,
    THEN_HALT,
    THEN_REBOOT
} h_then;


/* The GLOBAL struct */
typedef struct
{
    /* all the databases */
    s_call call_db;
    service_h service_cache;
    active_h active_database;
    /*history_h history_db; */
    m_h module_db;
    s_entry option_db;
    s_command command_db;

    /* global variables */
    h_sys_state sys_state;
    volatile int interrupt;
    int modules_to_unload;

    /* Argument data */
    char **Argv;
    int Argc;
    int maxproclen;
    char *Argv0;

    /* system state data */
    int i_am_init;
    char *runlevel;
    int when_out;

    /* use with THEN_NEW_INIT */
    char **new_init;
#ifdef DEBUG
    /* g.verbose_this
       0 = no verbose
       1 = all verbose
       2 = verbose whats in verbose_this
       3 = verbose all but, that is %this in verbose_this
     */
    int verbose;
    char *verbose_this[MAX_VERBOSES];
#endif

} s_global;

/* this is defined in initng_global.c */
extern s_global g;

/* functions for initziate and free s_global g */
void initng_new(int argc, char *argv[], char *env[]);
void initng_free(void);

#endif
